<template>
  <CModal
    :show.sync="isOpen"
    :close-on-backdrop="false"
    addContentClasses="modal-window"
  >
    <template #header>
      <h5>{{title}}</h5>
      <CButton
        variant="ghost"
        @click="closeModal(false)"
      >
        <CIcon
          name="cilX"
        />
      </CButton>
    </template>
    <template #footer>
      <CButton
        color="secondary"
        @click="closeModal(false)"
      >
        Отмена
      </CButton>
      <CButton
        color="primary"
        @click="closeModal(true)"
      >
        {{action}}
      </CButton>
    </template>
    <p>Вы уверены что хотите {{action.toLocaleLowerCase()}} пользователя {{user.name}} ?</p>
  </CModal>
</template>

<script>
  import modalClosingDuration from "../../../../constants/modalClosingDuration";

  export default {
    name: "BlockingUser",
    props: {
      isOpen: {
        // Состояние модального окна
        type: Boolean,
        default: false,
      },
      userInfo: {
        // Информация о блокируемом/разблокируемом пользователе
        type: Object,
        default() {
          return {};
        },
      },
    },
    data() {
      return {
        user: {},
      };
    },
    computed: {
      title() {
        const blockString = 'Блокирование';
        const unblockString = 'Разблокирование';
        const userString = 'пользователя'
        const {isBlocked} = this.user;
        return `${isBlocked ? unblockString : blockString} ${userString}`;
      },
      action() {
        const blockString = 'Заблокировать';
        const unblockString = 'Разблокировать';
        const {isBlocked} = this.user;
        return isBlocked ? unblockString : blockString;
      },
    },
    watch: {
      isOpen(value) {
        if (!value) {
          setTimeout(() => this.clearData(), modalClosingDuration);
        }
      },
      userInfo(userInfo) {
        if (this.isOpen) {
          this.user = {...userInfo};
        }
      },
    },
    methods: {
      closeModal(closeType) {
        this.$emit('onClose',
          {closeType, data: {...this.user, isBlocked: !this.user.isBlocked}, modalType: 'blockUser'},
        );
      },
      clearData() {
        this.user = {};
      },
    }
  }
</script>
